Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPTW/MDCVRPTWEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPTW/MDCVRPTWEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPTW/MDCVRPTWEvaluator.cs	(revision 17698)
@@ -45,5 +45,5 @@
     }
 
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -161,5 +161,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPEvaluator.cs	(revision 17698)
@@ -30,5 +30,5 @@
   [StorableType("AFC33483-2E8A-4469-8216-1F4FEE0AEB51")]
   public class MultiDepotVRPEvaluator : VRPEvaluator {
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -66,5 +66,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       StopInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index);
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPProblemInstance.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPProblemInstance.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MultiDepotVRPProblemInstance.cs	(revision 17698)
@@ -116,5 +116,5 @@
     }
 
-    public int GetDepot(int customer, IVRPEncoding solution) {
+    public int GetDepot(int customer, IVRPEncodedSolution solution) {
       int depot = -1;
 
@@ -131,5 +131,5 @@
     }
 
-    public override double GetDistance(int start, int end, IVRPEncoding solution) {
+    public override double GetDistance(int start, int end, IVRPEncodedSolution solution) {
       if (start == 0 && end == 0)
         return 0;
@@ -149,5 +149,5 @@
     }
 
-    public override double GetInsertionDistance(int start, int customer, int end, IVRPEncoding solution,
+    public override double GetInsertionDistance(int start, int customer, int end, IVRPEncodedSolution solution,
       out double startDistance, out double endDistance) {
       if (start == 0) {
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPEvaluator.cs	(revision 17698)
@@ -40,5 +40,5 @@
     }
 
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour))); ;
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -98,5 +98,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPInsertionInfo;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPPDTW/CVRPPDTWEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPPDTW/CVRPPDTWEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPPDTW/CVRPPDTWEvaluator.cs	(revision 17698)
@@ -42,5 +42,5 @@
     }
 
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -167,5 +167,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPPDTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPPDTWInsertionInfo;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs	(revision 17698)
@@ -45,5 +45,5 @@
     }
 
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -149,5 +149,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs	(revision 17698)
@@ -30,5 +30,5 @@
   [StorableType("1E0DECD9-54BF-4F69-A743-228C481749A0")]
   public class SingleDepotVRPEvaluator : VRPEvaluator {
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -66,5 +66,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       StopInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index);
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs	(revision 17698)
@@ -32,6 +32,6 @@
   [StorableType("164315D4-BCCF-4A79-B75B-11A49C56C5E1")]
   public abstract class VRPEvaluator : VRPOperator, IVRPEvaluator {
-    public ILookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ILookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ILookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ILookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
 
@@ -57,5 +57,5 @@
 
     public VRPEvaluator() {
-      Parameters.Add(new LookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new LookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
 
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The evaluated quality of the VRP solution."));
@@ -74,5 +74,5 @@
     }
 
-    protected abstract void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution);
+    protected abstract void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution);
 
     protected virtual void InitResultParameters() {
@@ -96,7 +96,7 @@
     }
 
-    protected abstract double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer, out bool feasible);
+    protected abstract double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer, out bool feasible);
 
-    public double GetInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, VRPEvaluation eval, int customer, int tour, int index, out bool feasible) {
+    public double GetInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, VRPEvaluation eval, int customer, int tour, int index, out bool feasible) {
       bool tourFeasible;
       double costs = GetTourInsertionCosts(
@@ -112,5 +112,5 @@
     }
 
-    public VRPEvaluation EvaluateTour(IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    public VRPEvaluation EvaluateTour(IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       VRPEvaluation evaluation = CreateTourEvaluation();
       EvaluateTour(evaluation, instance, tour, solution);
@@ -118,5 +118,5 @@
     }
 
-    public virtual VRPEvaluation Evaluate(IVRPProblemInstance instance, IVRPEncoding solution) {
+    public virtual VRPEvaluation Evaluate(IVRPProblemInstance instance, IVRPEncodedSolution solution) {
       VRPEvaluation evaluation = CreateTourEvaluation();
 
@@ -132,5 +132,5 @@
 
       VRPEvaluation evaluation = CreateTourEvaluation();
-      IVRPEncoding solution = VRPToursParameter.ActualValue;
+      IVRPEncodedSolution solution = VRPToursParameter.ActualValue;
       foreach (Tour tour in solution.GetTours()) {
         EvaluateTour(evaluation, ProblemInstance, tour, solution);
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 17698)
@@ -23,9 +23,9 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 using HeuristicLab.Problems.VehicleRouting.Encodings.General;
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
@@ -178,5 +178,4 @@
         return evaluator;
       }
-
       set {
         lock (locker) {
@@ -188,5 +187,5 @@
     }
 
-    public virtual double GetDistance(int start, int end, IVRPEncoding solution) {
+    public virtual double GetDistance(int start, int end, IVRPEncodedSolution solution) {
       if (distanceMatrix == null && UseDistanceMatrix.Value) {
         distanceMatrix = DistanceMatrix ?? CreateDistanceMatrix();
@@ -197,5 +196,5 @@
     }
 
-    public virtual double GetInsertionDistance(int start, int customer, int end, IVRPEncoding solution,
+    public virtual double GetInsertionDistance(int start, int customer, int end, IVRPEncodedSolution solution,
       out double startDistance, out double endDistance) {
       double distance = GetDistance(start, end, solution);
@@ -209,5 +208,5 @@
     }
 
-    public bool Feasible(IVRPEncoding solution) {
+    public bool Feasible(IVRPEncodedSolution solution) {
       return evaluator.Feasible(
         evaluator.Evaluate(
@@ -215,5 +214,5 @@
     }
 
-    public bool TourFeasible(Tour tour, IVRPEncoding solution) {
+    public bool TourFeasible(Tour tour, IVRPEncodedSolution solution) {
       return evaluator.Feasible(
         evaluator.EvaluateTour(
@@ -221,9 +220,9 @@
     }
 
-    public VRPEvaluation Evaluate(IVRPEncoding solution) {
+    public VRPEvaluation Evaluate(IVRPEncodedSolution solution) {
       return evaluator.Evaluate(this, solution);
     }
 
-    public VRPEvaluation EvaluateTour(Tour tour, IVRPEncoding solution) {
+    public VRPEvaluation EvaluateTour(Tour tour, IVRPEncodedSolution solution) {
       return evaluator.EvaluateTour(this, tour, solution);
     }
@@ -233,5 +232,5 @@
     }
 
-    public double GetInsertionCosts(VRPEvaluation eval, IVRPEncoding solution, int customer, int tour, int index, out bool feasible) {
+    public double GetInsertionCosts(VRPEvaluation eval, IVRPEncodedSolution solution, int customer, int tour, int index, out bool feasible) {
       return evaluator.GetInsertionCosts(this, solution, eval, customer, tour, index, out feasible);
     }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/SimilarityCalculators/VRPSimilarityCalculator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/SimilarityCalculators/VRPSimilarityCalculator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/SimilarityCalculators/VRPSimilarityCalculator.cs	(revision 17698)
@@ -57,5 +57,5 @@
     }
 
-    public static double CalculateSimilarity(PotvinEncoding left, PotvinEncoding right) {
+    public static double CalculateSimilarity(PotvinEncodedSolution left, PotvinEncodedSolution right) {
       if (left == null || right == null)
         throw new ArgumentException("Cannot calculate similarity because one of the provided solutions or both are null.");
@@ -93,9 +93,9 @@
 
     public override double CalculateSolutionSimilarity(IScope leftSolution, IScope rightSolution) {
-      var sol1 = leftSolution.Variables[SolutionVariableName].Value as IVRPEncoding;
-      var sol2 = rightSolution.Variables[SolutionVariableName].Value as IVRPEncoding;
+      var sol1 = leftSolution.Variables[SolutionVariableName].Value as IVRPEncodedSolution;
+      var sol2 = rightSolution.Variables[SolutionVariableName].Value as IVRPEncodedSolution;
 
-      var potvinSol1 = sol1 is PotvinEncoding ? sol1 as PotvinEncoding : PotvinEncoding.ConvertFrom(sol1, ProblemInstance);
-      var potvinSol2 = sol2 is PotvinEncoding ? sol2 as PotvinEncoding : PotvinEncoding.ConvertFrom(sol2, ProblemInstance);
+      var potvinSol1 = sol1 is PotvinEncodedSolution ? sol1 as PotvinEncodedSolution : PotvinEncodedSolution.ConvertFrom(sol1, ProblemInstance);
+      var potvinSol2 = sol2 is PotvinEncodedSolution ? sol2 as PotvinEncodedSolution : PotvinEncodedSolution.ConvertFrom(sol2, ProblemInstance);
 
       return CalculateSimilarity(potvinSol1, potvinSol2);
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs	(revision 17698)
@@ -24,4 +24,5 @@
 using System.Drawing;
 using System.Linq;
+using System.Threading;
 using HEAL.Attic;
 using HeuristicLab.Analysis;
@@ -44,6 +45,5 @@
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems, Priority = 110)]
   [StorableType("95137523-AE3B-4638-958C-E86829D54CE3")]
-  public sealed class VehicleRoutingProblem : EncodedProblem, ISingleObjectiveHeuristicOptimizationProblem, IStorableContent, IProblemInstanceConsumer<IVRPData> {
-    public string Filename { get; set; }
+  public sealed class VehicleRoutingProblem : SingleObjectiveProblem<AlbaEncoding, AlbaEncodedSolution>, IProblemInstanceConsumer<IVRPData> {
 
     public static new Image StaticItemImage {
@@ -52,27 +52,9 @@
 
     #region Parameter Properties
-    public ValueParameter<BoolValue> MaximizationParameter {
-      get { return (ValueParameter<BoolValue>)Parameters["Maximization"]; }
-    }
-    IParameter ISingleObjectiveHeuristicOptimizationProblem.MaximizationParameter {
-      get { return MaximizationParameter; }
-    }
     public ValueParameter<IVRPProblemInstance> ProblemInstanceParameter {
       get { return (ValueParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public OptionalValueParameter<DoubleValue> BestKnownQualityParameter {
-      get { return (OptionalValueParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
-    }
-    IParameter ISingleObjectiveHeuristicOptimizationProblem.BestKnownQualityParameter {
-      get { return BestKnownQualityParameter; }
-    }
     public OptionalValueParameter<VRPSolution> BestKnownSolutionParameter {
       get { return (OptionalValueParameter<VRPSolution>)Parameters["BestKnownSolution"]; }
-    }
-    public IValueParameter<IVRPEvaluator> EvaluatorParameter {
-      get { return (IValueParameter<IVRPEvaluator>)Parameters["Evaluator"]; }
-    }
-    IParameter IHeuristicOptimizationProblem.EvaluatorParameter {
-      get { return EvaluatorParameter; }
     }
     #endregion
@@ -88,17 +70,4 @@
       set { BestKnownSolutionParameter.Value = value; }
     }
-
-    public DoubleValue BestKnownQuality {
-      get { return BestKnownQualityParameter.Value; }
-      set { BestKnownQualityParameter.Value = value; }
-    }
-
-    public ISingleObjectiveEvaluator Evaluator {
-      get { return EvaluatorParameter.Value; }
-    }
-
-    IEvaluator IHeuristicOptimizationProblem.Evaluator {
-      get { return this.Evaluator; }
-    }
     #endregion
 
@@ -106,13 +75,7 @@
     private VehicleRoutingProblem(StorableConstructorFlag _) : base(_) { }
     public VehicleRoutingProblem()
-      : base() {
-      Parameters.Add(new ValueParameter<BoolValue>("Maximization", "Set to false as the Vehicle Routing Problem is a minimization problem.", new BoolValue(false)));
+      : base(new AlbaEncoding()) {
       Parameters.Add(new ValueParameter<IVRPProblemInstance>("ProblemInstance", "The VRP problem instance"));
-      Parameters.Add(new OptionalValueParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution of this VRP instance."));
       Parameters.Add(new OptionalValueParameter<VRPSolution>("BestKnownSolution", "The best known solution of this VRP instance."));
-
-      Parameters.Add(new ValueParameter<IVRPEvaluator>("Evaluator", "The operator which should be used to evaluate VRP solutions."));
-
-      EvaluatorParameter.Hidden = true;
 
       InitializeRandomVRPInstance();
@@ -121,6 +84,4 @@
       AttachEventHandlers();
       AttachProblemInstanceEventHandlers();
-
-      EvaluatorParameter.Value = ProblemInstance.SolutionEvaluator;
     }
 
@@ -134,15 +95,9 @@
       this.AttachEventHandlers();
       this.AttachProblemInstanceEventHandlers();
-
-      ProblemInstance.SolutionEvaluator = EvaluatorParameter.Value;
-    }
-
-    #region Events
-    public event EventHandler EvaluatorChanged;
-    private void OnEvaluatorChanged() {
-      EventHandler handler = EvaluatorChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-    #endregion
+    }
+
+    public override ISingleObjectiveEvaluationResult Evaluate(AlbaEncodedSolution solution, IRandom random, CancellationToken cancellationToken) {
+      return new SingleObjectiveEvaluationResult(ProblemInstance.Evaluate(solution).Quality);
+    }
 
     #region Helpers
@@ -151,6 +106,4 @@
       AttachEventHandlers();
       AttachProblemInstanceEventHandlers();
-
-      ProblemInstance.SolutionEvaluator = EvaluatorParameter.Value;
     }
 
@@ -163,5 +116,4 @@
       ProblemInstanceParameter.ValueChanged += new EventHandler(ProblemInstanceParameter_ValueChanged);
       BestKnownSolutionParameter.ValueChanged += new EventHandler(BestKnownSolutionParameter_ValueChanged);
-      EvaluatorParameter.ValueChanged += new EventHandler(EvaluatorParameter_ValueChanged);
     }
 
@@ -176,8 +128,8 @@
       try {
         //call evaluator
-        BestKnownQuality = new DoubleValue(ProblemInstance.Evaluate(BestKnownSolution.Solution).Quality);
-        BestKnownSolution.Quality = BestKnownQuality;
+        BestKnownQuality = ProblemInstance.Evaluate(BestKnownSolution.Solution).Quality;
+        BestKnownSolution.Quality = new DoubleValue(BestKnownQuality);
       } catch {
-        BestKnownQuality = null;
+        BestKnownQuality = double.NaN;
         BestKnownSolution = null;
       }
@@ -189,5 +141,5 @@
 
     void ProblemInstance_EvaluationChanged(object sender, EventArgs e) {
-      BestKnownQuality = null;
+      BestKnownQuality = double.NaN;
       if (BestKnownSolution != null) {
         // the tour is not valid if there are more vehicles in it than allowed
@@ -202,7 +154,4 @@
       AttachProblemInstanceEventHandlers();
 
-      EvaluatorParameter.Value = ProblemInstance.SolutionEvaluator;
-
-      OnEvaluatorChanged();
       OnOperatorsChanged();
     }
@@ -214,13 +163,5 @@
       AttachProblemInstanceEventHandlers();
 
-      OnEvaluatorChanged();
-
       ProblemInstanceParameter.ValueChanged += new EventHandler(ProblemInstanceParameter_ValueChanged);
-    }
-
-    private void EvaluatorParameter_ValueChanged(object sender, EventArgs e) {
-      if (ProblemInstance != null)
-        ProblemInstance.SolutionEvaluator = EvaluatorParameter.Value;
-      OnEvaluatorChanged();
     }
 
@@ -247,8 +188,13 @@
       }
 
-      ParameterizeOperators();
-    }
-
-    private void ParameterizeOperators() {
+      Parameterize();
+    }
+
+    protected override void ParameterizeOperators() {
+      base.ParameterizeOperators();
+      Parameterize();
+    }
+
+    private void Parameterize() {
       foreach (IOperator op in Operators.OfType<IOperator>()) {
         if (op is IMultiVRPOperator) {
@@ -256,5 +202,5 @@
         }
       }
-      if (ProblemInstance != null) {
+      if (Parameters.ContainsKey("ProblemInstance") && ProblemInstance != null) {
         foreach (ISingleObjectiveImprovementOperator op in Operators.OfType<ISingleObjectiveImprovementOperator>()) {
           //op.SolutionParameter.ActualName = SolutionCreator.VRPToursParameter.ActualName;
@@ -315,5 +261,5 @@
       parser.Parse();
 
-      HeuristicLab.Problems.VehicleRouting.Encodings.Potvin.PotvinEncoding encoding = new Encodings.Potvin.PotvinEncoding(ProblemInstance);
+      HeuristicLab.Problems.VehicleRouting.Encodings.Potvin.PotvinEncodedSolution encoding = new Encodings.Potvin.PotvinEncodedSolution(ProblemInstance);
 
       int cities = 0;
@@ -341,5 +287,5 @@
       Description = instance.Description;
 
-      BestKnownQuality = null;
+      BestKnownQuality = double.NaN;
       BestKnownSolution = null;
 
@@ -353,5 +299,5 @@
 
       if (instance.BestKnownQuality != null) {
-        BestKnownQuality = new DoubleValue((double)instance.BestKnownQuality);
+        BestKnownQuality = instance.BestKnownQuality ?? double.NaN;
       }
 
@@ -383,5 +329,4 @@
       return interpreterInterface.GetGenericArguments()[0];
     }
-
     #endregion
   }
